"use client";

import { toast } from "sonner";
import { useMutation, useQueryClient } from "@tanstack/react-query";

import {
    Form,
    FormControl,
    FormField,
    FormItem,
    FormLabel,
    FormMessage,
} from "@/components/ui/form";

import React, { useState } from "react";
import { ErrorResponseProps } from "@/lib/features/admin/account/type";
import { useForm } from "react-hook-form";
import { zodResolver } from "@hookform/resolvers/zod";
import { z } from "zod";
import { Input } from "@/components/ui/input";
import { Button } from "@/components/ui/button";
import { LoaderCircle } from "lucide-react";
import { ResponseProps } from "@/lib/features/login/type";
import { Textarea } from "@/components/ui/textarea";
import { createQuiz } from "@/lib/features/admin/quiz/service";
import { QuizFormValidation } from "@/lib/features/admin/quiz/schema";

interface Props {
    onCloseModal: () => void;
    refreshNow: () => void;
}

export const QuizFormDialog = ({ onCloseModal, refreshNow }: Props) => {

    // states
    const [title, setTitle] = useState('');
    const [desc, setDesc] = useState('');

    const [image, setImage] = useState('');
    const [sending, setSending] = useState(false);



    const queryClient = useQueryClient();

    const mutation = useMutation({
        mutationFn: createQuiz,
        onSuccess: (data) => {
            queryClient.invalidateQueries({ queryKey: ["createNewQuiz"] });

            const response = data as unknown as ResponseProps;


            if (response?.data?.message) {
                toast.success(response?.data?.message);

                // close modal
                onCloseModal();

                //refresh clubs
                refreshNow();

            } else {
                toast.error(response?.data?.error);
                setSending(false);
            }

            //window.location.reload();
        },
        onError: (error) => {

            const newError = error as unknown as ErrorResponseProps;
            toast.error(newError?.response?.data?.message);

            return false;
            //window.location.reload();
        },
    });

    function onSubmit() {

        if (title === null || title === '') {
            toast.error("Title is required");
            return false;
        }

        else if (desc === null || desc === '') {
            toast.error("Description is required");
            return false;
        }

        else if (image === null || image === '') {
            toast.error("Image url is required");
            return false;
        }

        else {

            setSending(true);

            const body = {
                title: title,
                description: desc,
                image: image
            }

            // console.log(JSON.stringify(body));
            // return false;

            mutation.mutate(body);
        }
    }



    // Form setup
    const form = useForm<z.infer<typeof QuizFormValidation>>({
        resolver: zodResolver(QuizFormValidation),
        defaultValues: {
        },
    });


    return (
        <div>
            <div className="text-sm font-medium text-center text-neutral-600 pb-4">
                Create new quiz
            </div>

            <Form {...form}>
                <form className="space-y-6">
                    <div className="grid gap-2">

                        <div className="grid grid-cols-1 gap-2">

                            <FormField
                                control={form.control}
                                name="title"
                                render={({ }) => (
                                    <FormItem>
                                        <FormLabel>Title</FormLabel>
                                        <FormControl>
                                            <Input type="text" value={title} onChange={(e) => setTitle(e.target.value)} />
                                        </FormControl>
                                        <FormMessage />
                                    </FormItem>
                                )}
                            />

                            <FormField
                                control={form.control}
                                name="description"
                                render={({ }) => (
                                    <FormItem>
                                        <FormLabel>Description</FormLabel>
                                        <FormControl>
                                            <Textarea value={desc} onChange={(e) => setDesc(e.target.value)} />
                                        </FormControl>
                                        <FormMessage />
                                    </FormItem>
                                )}
                            />

                            <FormField
                                control={form.control}
                                name="image"
                                render={({ }) => (
                                    <FormItem>
                                        <FormLabel>Image</FormLabel>
                                        <FormControl>
                                            <Input type="text" value={image} onChange={(e) => setImage(e.target.value)} />
                                        </FormControl>
                                        <FormMessage />
                                    </FormItem>
                                )}
                            />


                        </div>

                        <Button className="confirm-button mt-4" type="button" onClick={onSubmit}  >
                            {sending ?
                                <LoaderCircle className="animate-spin" />
                                : "SAVE"
                            }
                        </Button>
                    </div>
                </form>
            </Form>
        </div>
    );

}